include <library.scad>

module dealigned_column() difference() {
	translate([-slot_separation/2, -slot_separation/2, -unit/2]) cube([slot_separation, slot_separation, unit-grid/2]);
	vslots_z_negative();
	translate([0, 0, -grid/2]) vslots_z_positive();
}

// module dealigned_merge() difference() {
// 	slot_height = slot_clip_length+slot_lip;
// 
// 	translate([0, 0, slot_lip_fudge-slot_separation/2]) linear_extrude(slot_separation-slot_lip_fudge) polygon([
// 		[-slot_separation/2, unit/2],
// 		[slot_separation/2, unit/2],
// 		[slot_separation/2, unit/2-slot_height],
// 		[grid/2+slot_separation/2, slot_height-unit/2],
// 		[grid/2+slot_separation/2, -unit/2],
// 		[grid/2-slot_separation/2, -unit/2],
// 		[grid/2-slot_separation/2, slot_height-unit/2],
// 		// [0, slot_height+(grid-slot_separation)/2-unit/2],
// 		[slot_separation/2-grid/2, slot_height-unit/2],
// 		[slot_separation/2-grid/2, -unit/2],
// 		[-grid/2-slot_separation/2, -unit/2],
// 		[-grid/2-slot_separation/2, slot_height-unit/2],
// 		[-slot_separation/2, unit/2-slot_height],
// 	]);
// 	translate([-grid/2, 0, 0]) vslots_y_negative();
// 	translate([grid/2, 0, 0]) vslots_y_negative();
// 	vslots_y_positive();
// }

module dealigned_merge() {
	slot_height = slot_clip_length+slot_lip;

	difference() {
		rotate(-90, [1, 0, 0]) linear_extrude(slot_separation, center=true) polygon([
			[-slot_separation/2, unit/2],
			[slot_separation/2, unit/2],
			[slot_separation/2, unit/2-slot_height],
			[grid/2+slot_separation/2, slot_height-unit/2],
			[grid/2+slot_separation/2, -unit/2],
			[grid/2-slot_separation/2, -unit/2],
			[grid/2-slot_separation/2, slot_height-unit/2],
			// [0, slot_height+(grid-slot_separation)/2-unit/2],
			[slot_separation/2-grid/2, slot_height-unit/2],
			[slot_separation/2-grid/2, -unit/2],
			[-grid/2-slot_separation/2, -unit/2],
			[-grid/2-slot_separation/2, slot_height-unit/2],
			[-slot_separation/2, unit/2-slot_height],
		]);
		vslots_z_negative();
		translate([-grid/2, 0, 0]) vslots_z_positive();
		translate([grid/2, 0, 0]) vslots_z_positive();
	}

	difference() {
		cube([slot_separation, unit, slot_separation], center=true);
		vslots_y_negative();
		vslots_y_positive();
	}

	support(1, 1);
}

dealigned_column();
translate([grid*2, 0, 0]) dealigned_merge();
